//
// index.hh
// 
// Made by vicen
// Login   <vicen@localhost.localdomain>
// 
// Started on  Sun Apr 30 19:21:10 2006 vicen
// Last update Sun Apr 30 19:21:10 2006 vicen
//

#ifndef   	INDEX_HH_
#define   	INDEX_HH_

#include<vector>
#include<iostream>

using namespace std;

/// The PIndex class

/**
   This class is used to address the values
 */

typedef unsigned int uint;

class PIndex : public vector<vector<uint> >
{
protected:

  vector<int> m_sizes;

public:

  void addVar(int var_size) {
    int last_size = size();
    if (!size()) {
      for (int i=0; i<var_size; i++) {
        vector<uint> v(1,i);
        push_back(v);
      }
    }
    else {
      PIndex v = (*this);
      for (int i=0; i<(var_size-1); i++)
	insert(begin(), v.begin(), v.end());
      for (uint i=0, j=0; i<size(); i++) {
	if (i && !(i%last_size) ) j++;
	at(i).push_back(j);
      }
    }
    m_sizes.push_back(var_size);
  }
  int getNVars() { return m_sizes.size(); }
  int getNVals() { int nvals=1; for (uint i=0; i<m_sizes.size(); i++) nvals *= m_sizes[i]; return nvals; }

  // a 2d index between an arbitrary inner var and the outer variable
  vector<int> getIndexM(int var1) {
    vector<int> newidx;
    int var2 = m_sizes.size()-1;
    for (uint i=0; i<size(); i++)
      newidx.push_back(at(i)[var1] + m_sizes[var1]*at(i)[var2]);
    return newidx;
  }

  // a 2d index between two arbitrary vars such that var1 < var2
  // ASSERT var1 < var 2 in the other factor!!
  vector<int> getIndex2(int var1, int var2) {
    vector<int> newidx;
    for (uint i=0; i<size(); i++) {
      newidx.push_back(at(i)[var1] + m_sizes[var1]*at(i)[var2]);
    }
    return newidx;
  }

  void addValue() {
    
  }

  uint get(int i, int j) { return at(i)[j]; } 


  friend std::ostream& operator<< (std::ostream& os, PIndex idx)
  {
    for (vector<vector<uint> >::iterator it = idx.begin(); it != idx.end(); it++) {
      for (vector<uint>::iterator it2 = (*it).begin(); it2 != (*it).end(); it2++)
        os << *it2 << " ";
      os << std::endl;
    }
    return os;
  }

};



#endif	    /* !INDEX_HH_ */
